#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <cstrike>

#include <laper32>

int   g_iRCIdx[MAXPLAYERS+1];
float g_flRCLastThink[MAXPLAYERS+1];

int   g_beamsprite;

public Plugin myinfo = 
{
    name        = "Rail Cannon",
    author      = "Kroytz",
    description = "",
    version     = "1.0",
    url         = "http://github.com/Kroytz"
};

public void OnPluginStart()
{
    // event hooks
    RegAdminCmd("sm_rc", Clcmd_Test, ADMFLAG_ROOT, "Try rail cannon");

    HookEvent("bullet_impact", Event_OnBulletImpact, EventHookMode_Post);
    HookEvent("player_death", Event_OnPlayerDeath);
    HookEvent("round_start", Event_OnRoundStart);
}

public void OnMapStart()
{
    g_beamsprite = PrecacheModel("materials/sprites/laserbeam.vmt");
}

public void OnClientPostAdminCheck(int client)
{
    g_iRCIdx[client] = -1;
    g_flRCLastThink[client] = 0.0;
}

public Action Clcmd_Test(int client, int args)
{
    int weapon = ToolsGetActiveWeapon(client);

    if (!IsValidEdict(weapon))
        return;

    // PrintToChatAll("weapon -> %d", weapon);

    float vecOrigin[3];
    // float vecAngle[3];
    char szModel[256];

    GetClientEyePosition(client, vecOrigin);
    // GetClientEyeAngles(client, vecAngle);

    vecOrigin[2] += 35.0;

    GetEntPropString(weapon, Prop_Data, "m_ModelName", szModel, 256);
    ReplaceString(szModel, 256, "_dropped", "", false);

    // PrintToChatAll("szModel -> %s", szModel);

    g_iRCIdx[client] = CreateEntityByName("prop_dynamic_glow");

    if(g_iRCIdx[client] == -1)
        return;

    // PrintToChatAll("glow -> %d", g_iRCIdx[client]);

    DispatchKeyValue(g_iRCIdx[client], "model",                 szModel);
    DispatchKeyValue(g_iRCIdx[client], "disablereceiveshadows", "1");
    DispatchKeyValue(g_iRCIdx[client], "disableshadows",        "1");
    DispatchKeyValue(g_iRCIdx[client], "solid",                 "0");
    DispatchKeyValue(g_iRCIdx[client], "spawnflags",            "256");

    DispatchSpawn(g_iRCIdx[client]);

    SetEntProp(g_iRCIdx[client], Prop_Send, "m_CollisionGroup", 11);
    SetEntProp(g_iRCIdx[client], Prop_Send, "m_bShouldGlow",    true, true);

    SetEntPropFloat(g_iRCIdx[client], Prop_Send, "m_flGlowMaxDist", 100000.0);

    SetEntityRenderMode(g_iRCIdx[client],  RENDER_TRANSCOLOR);
    SetEntityRenderColor(g_iRCIdx[client], 255, 50, 150, 0);

    SetGlowColor(g_iRCIdx[client], 255,  50, 150);

    TeleportEntity(g_iRCIdx[client], vecOrigin, NULL_VECTOR, NULL_VECTOR);

    SetEntPropEnt(g_iRCIdx[client], Prop_Send, "m_hOwnerEntity", client);
    ToolsSetParent(g_iRCIdx[client], client);
    ToolsSetOwner(g_iRCIdx[client], client);

    // Hooks
    SDKHook(client, SDKHook_WeaponSwitchPost, SDKHookCB_WeaponSwitchPost);
    // SDKHook(client, SDKHook_PostThinkPost, SDKHookCB_PostThinkPost);
}

// public void SDKHookCB_PostThinkPost(int client)
public void OnGameFrame()
{
    for (int client = 1; client <= MaxClients; client ++)
    {
        if (IsPlayerExist(client))
        {
            if (g_iRCIdx[client] != -1)
            {
                if (GetGameTime() >= g_flRCLastThink[client])
                {
                    if (IsValidEdict(g_iRCIdx[client]))
                    {
                        float vecAngle[3];
                        GetEntPropVector(g_iRCIdx[client], Prop_Send, "m_angRotation", vecAngle);
                        vecAngle[0] = 0.0;
                        vecAngle[1] += 5.0;

                        float vecOrigin[3];
                        GetClientEyePosition(client, vecOrigin);

                        if(GetClientButtons(client) & IN_DUCK)
                            vecOrigin[2] += 30.0;
                        else
                            vecOrigin[2] += 47.0;

                        TeleportEntity(g_iRCIdx[client], vecOrigin, vecAngle, NULL_VECTOR);
                    }
                    else
                    {
                        g_iRCIdx[client] = -1;
                        g_flRCLastThink[client] = 0.0;
                    }
                }
            }
        }
        else
        {
            SDKUnhook(client, SDKHook_WeaponSwitchPost, SDKHookCB_WeaponSwitchPost);
            // SDKUnhook(client, SDKHook_PostThinkPost, SDKHookCB_PostThinkPost);
        }
    }
}

public void SDKHookCB_WeaponSwitchPost(int client, int weapon) 
{ 
    if (!IsValidEdict(weapon))
        return;

    if (!IsValidEdict(g_iRCIdx[client]))
        return;

    char szModel[256];
    GetEntPropString(weapon, Prop_Data, "m_ModelName", szModel, 256);
    ReplaceString(szModel, 256, "_dropped", "", false);

    SetEntityModel(g_iRCIdx[client], szModel);
}

public Action Event_OnBulletImpact(Event event, const char[] name, bool dontBroadcast) 
{
    int client = GetClientOfUserId(event.GetInt("userid"));

    if (IsPlayerExist(client))
    {
        if (g_iRCIdx[client] != -1)
        {
            if (IsValidEdict(g_iRCIdx[client]))
            {
                // Initialize vector
                float vBullet[3];

                // Gets bullet position
                vBullet[0] = event.GetFloat("x");
                vBullet[1] = event.GetFloat("y");
                vBullet[2] = event.GetFloat("z");

                SniperCreateBeam(client, vBullet);

                g_flRCLastThink[client] = GetGameTime() + 0.3;
            }
        }
    }
}

public Action Event_OnRoundStart(Event event, const char[] name, bool dontBroadcast)
{
    for (int i=1; i< MAXPLAYERS+1; i++)
    {
        g_iRCIdx[i] = -1;
        g_flRCLastThink[i] = 0.0;
    }
}

public Action Event_OnPlayerDeath(Event event, const char[] name, bool dontBroadcast) 
{
    int client = GetClientOfUserId(event.GetInt("userid"));

    if (g_iRCIdx[client] != -1)
    {
        if (IsValidEdict(g_iRCIdx[client]))
        {
            AcceptEntityInput(g_iRCIdx[client], "Kill");
            g_iRCIdx[client] = -1;
            g_flRCLastThink[client] = 0.0;
        }
    }
}

void SniperCreateBeam(int client, float vBullet[3])
{
    float vecOrigin[3];
    GetClientEyePosition(client, vecOrigin);

    if(GetClientButtons(client) & IN_DUCK)
        vecOrigin[2] += 30.0;
    else
        vecOrigin[2] += 47.0;

    TeleportEntity(g_iRCIdx[client], vecOrigin, NULL_VECTOR, NULL_VECTOR);

    // ______________________________ Bullet ______________________________ //

    float vRCOrigin[3];
    GetEntPropVector(g_iRCIdx[client], Prop_Send, "m_vecOrigin", vRCOrigin);

    float distance = GetVectorDistance( vRCOrigin, vBullet);
    float percentage = 0.4 / (distance / 100);
    float vnewRCOrigin[3];
    vnewRCOrigin[0] = vRCOrigin[0] + ( ( vBullet[0] - vRCOrigin[0] ) * percentage );
    vnewRCOrigin[1] = vRCOrigin[1] + ( ( vBullet[1] - vRCOrigin[1] ) * percentage );
    vnewRCOrigin[2] = vRCOrigin[2] + ( ( vBullet[2] - vRCOrigin[2] ) * percentage );

    float vBulletTrace[3]; float vRCAngle[3];
    MakeVectorFromPoints(vRCOrigin, vBullet, vBulletTrace);
    GetVectorAngles(vBulletTrace, vRCAngle);

    SetEntPropVector(g_iRCIdx[client], Prop_Send, "m_angRotation", vRCAngle);
    // TE_DispatchEffect("weapon_tracers_taser", vnewRCOrigin, vBullet, vRCAngle);
    // TE_SendToAll();

    int color[4] = {255,255,255,220};
    color[0] = GetRandomInt(1, 255);
    color[1] = GetRandomInt(1, 255);
    color[2] = GetRandomInt(1, 255);

    TE_SetupBeamPoints(vnewRCOrigin, vBullet, g_beamsprite, 0, 0, 0, 0.5, 7.0, 0.0, 1, 0.0, color, 0);
    TE_SendToAll();
}

static void SetGlowColor(int entity, int r, int g, int b)
{
    int colors[4];
    colors[0] = r;
    colors[1] = g;
    colors[2] = b;
    colors[3] = 255;
    SetVariantColor(colors);
    AcceptEntityInput(entity, "SetGlowColor");
}

stock void TE_DispatchEffect(char[] particle, const float pos[3], const float endpos[3], const float angles[3] = NULL_VECTOR)
{
    TE_Start("EffectDispatch");
    TE_WriteFloatArray("m_vStart.x", pos, 3);
    TE_WriteFloatArray("m_vOrigin.x", endpos, 3);
    TE_WriteVector("m_vAngles", angles);
    TE_WriteNum("m_nHitBox", GetParticleEffectIndex(particle));
    TE_WriteNum("m_iEffectName", GetEffectIndex("ParticleEffect"));
}